﻿#ifndef CWALLS_H
#define CWALLS_H

#include "../common/sources/system/cmaths.h"
#include "../common/sources/Map.h"
#include <vector>

#define WALL_TABLE_WIDTH    5
#define WALL_TABLE_HEIGHT   4

enum EWallTypes
{
    eWallNothing = 0,
    eWallSimple,
    eWallPortrait
};

class CWalls
{
public:
    struct COrnateData
    {
        QString name;
        QString imageFront;
        QString imageSide;
        CVec2   posFront;
        CVec2   posSide;
    };

    CWalls();

    CVec2       getDrawSequence(CVec2 pos);
    CVec2       getMapPos(CVec2 tablePos);
    const char* getFilename(CVec2 tablePos, EWallSide side, bool flip);
    CVec2       getGfxPos(CVec2 tablePos, EWallSide side, bool flip);
    void        readOrnatesDB();
    void        readWallsDB();
    int         getTableSide(EWallSide side, bool flip);
    void        drawOrnate(QImage* image, CVec2 tablePos, EWallSide side, int ornate);

    std::vector<COrnateData>  ornatesDatas;
};

extern CWalls   walls;

#endif // CWALLS_H
